# GeoApp: Project Manager for GeoDict

This is a small tool for GeoDict to simplify the creation of new projects.

The AddIn installs itself in the UserFolder of GeoDict (e.g. ~/.geodict2021) and creates some project templates there.
The project templates follow the [cookiecutter](https://github.com/cookiecutter/cookiecutter) format and can be adapted
to your own needs. The folder structure is inspired by the
[cookiecutter data sciene project](https://drivendata.github.io/cookiecutter-data-science/).

This AddIn is still in beta phase, so there may still be errors.Use at your own risk!

## Why

In my work I often have to switch between different GeoDict projects. To simplify this switch a bit I wrote this little 
tool. It also simplifies and standardizes the creation of new projects.

## Features

* Create a new project from existing project templates
* Add custom project templates
* Easily switch between projects and automatically load project settings:
  * color settings
  * view settings
  * planned: load project specific macros

## Installation

This is a Python Wheel and can be installed via the GeoDict Interface(see Install Python Package in the GeoDict
Userguide). For convenience, I have included a small Macro which takes care of the installation steps.

Just open GeoDict 2021, start the macro `ìnstall_gdpm.py`

select the corresponding python *.whl file (e.g. 'gdpm-0.0.7-py3-none-any') and run it. 

Restart GeoDict (Important!)

Now we have to finalize the setup process. Open GeoDict and use the GeoDict Command Line at the bottom to run the 
following command

    import gdpm

And then

    gdpm.setup()

Now you should see something like this

    Setup gdview for the current GeoDict installation
    ... installing app_scripts to /home/xxx/.geodict2021/GeoApp/Project Manager
    copy: /home/xxx/.geodict2021/Python/gdpm/templates/simulation to /home/xxx/.geodict2021/GeoApp/Project Manager/templates/simulation
    copy: /home/xxx/.geodict2021/Python/gdpm/templates/ct-analysis to /home/xxx/.geodict2021/GeoApp/Project Manager/templates/ct-analysis
    ... done, please restart GeoDict again.

Restart GeoDict again. You can use the Project Manager now via `GeoApp --> UserGeoApps --> Project Manager`

## Create your own project templates

You can use the existing templates and create your own. First make sure you understand the concept of 
[cookiecutter](https://github.com/cookiecutter/cookiecutter) 

Copy a project template in your `<GeoDict UserFolder>/GeoApp/Project Manager/` and adapt it to your needs 


## Bugs & Feature Requests

If you stumble upon a bug, have an idea for a new feature, or have any other feedback --> `geoapps@cvt-engineering.de`



